Index: issm/mobile/android/ISSM_APP/AndroidManifest.xml
===================================================================
--- issm/mobile/android/ISSM_APP/AndroidManifest.xml	(revision 15389)
+++ issm/mobile/android/ISSM_APP/AndroidManifest.xml	(revision 17423)
@@ -1,63 +1,71 @@
+<?xml version="1.0" encoding="utf-8"?>
 <manifest xmlns:android="http://schemas.android.com/apk/res/android"
     package="gov.nasa.jpl.issm"
+    android:installLocation="preferExternal"
     android:versionCode="1"
-    android:versionName="1.0"
-    android:installLocation="preferExternal" >
+    android:versionName="1.0" >
+
     <uses-sdk
-        android:minSdkVersion="10"
-        android:targetSdkVersion="15" />
-	<uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" />
-	<uses-permission android:name="android.permission.INTERNET" /> 
-	<uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
-	    
+        android:minSdkVersion="11"
+        android:targetSdkVersion="18" />
+
+    <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" />
+    <uses-permission android:name="android.permission.INTERNET" />
+    <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
+
     <application
         android:icon="@drawable/ic_launcher"
         android:label="@string/app_name"
         android:theme="@style/AppTheme" >
-        <activity android:name="gov.nasa.jpl.issm.ISSMAPP" 
-            	  android:screenOrientation="portrait"
-            	  android:label="@string/title_activity_issm"
-            	  android:noHistory="true" >
+        <activity
+            android:name="gov.nasa.jpl.issm.ISSMAPP"
+            android:label="@string/title_activity_issm"
+            android:noHistory="true"
+            android:screenOrientation="portrait" >
             <intent-filter>
                 <action android:name="android.intent.action.MAIN" />
-				<category android:name="android.intent.category.LAUNCHER" />
+
+                <category android:name="android.intent.category.LAUNCHER" />
             </intent-filter>
-            </activity>
-            <activity
+        </activity>
+        <activity
             android:name="gov.nasa.jpl.issm.MenuPage"
-            android:screenOrientation="portrait"
-            android:label="@string/title_activity_issm" >
+            android:label="@string/title_activity_issm"
+            android:screenOrientation="portrait" >
         </activity>
         <activity
             android:name="gov.nasa.jpl.issm.VideoActivity"
-            android:screenOrientation="portrait"
-            android:label="@string/title_video_issm" >
+            android:label="@string/title_video_issm"
+            android:screenOrientation="landscape" >
         </activity>
         <activity
             android:name="gov.nasa.jpl.issm.ZoomImageViewActivity"
-            android:screenOrientation="portrait"
-            android:label="@string/title_activity_issm" >
+            android:label="@string/title_activity_issm"
+            android:screenOrientation="portrait" >
         </activity>
         <activity
             android:name="gov.nasa.jpl.issm.AboutActivity"
-            android:screenOrientation="portrait"
-            android:label="@string/title_activity_issm" >
+            android:label="@string/title_activity_issm"
+            android:screenOrientation="portrait" >
         </activity>
-         <activity
+        <activity
             android:name="gov.nasa.jpl.issm.TeamActivity"
-            android:screenOrientation="portrait"
-            android:label="@string/title_activity_issm" >
+            android:label="@string/title_activity_issm"
+            android:screenOrientation="portrait" >
         </activity>
         <activity
             android:name="gov.nasa.jpl.issm.ISSM"
-            android:screenOrientation="portrait"
-            android:label="@string/title_activity_issm" >
+            android:label="@string/title_activity_issm"
+            android:screenOrientation="portrait" >
         </activity>
         <activity
             android:name="gov.nasa.jpl.issm.GalleryImage"
-            android:screenOrientation="portrait"
-            android:label="@string/title_activity_issm" >
+            android:label="@string/title_activity_issm"
+            android:screenOrientation="portrait" >
         </activity>
-       
+        <activity
+            android:name="gov.nasa.jpl.issm.ISSMWebActivity"
+            android:label="@string/title_activity_issmweb_online" android:configChanges="orientation|screenSize">
+        </activity>
     </application>
 