Index: issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 17674)
+++ issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 17686)
@@ -7,5 +7,5 @@
 
 /*Model processing*/
-int  HydrologyDCInefficientAnalysis::DofsPerNode(int** doflist,int meshxdim,int approximation){/*{{{*/
+int  HydrologyDCInefficientAnalysis::DofsPerNode(int** doflist,int domaintype,int approximation){/*{{{*/
 	return 1;
 }/*}}}*/
@@ -88,5 +88,5 @@
 	iomodel->FetchDataToInput(elements,SedimentHeadEnum);
 	iomodel->FetchDataToInput(elements,HydrologydcSedimentTransmitivityEnum);
-	if(iomodel->meshxdim==Mesh3DEnum) iomodel->FetchDataToInput(elements,MeshElementonbaseEnum);
+	if(iomodel->domaintype==Mesh3DEnum) iomodel->FetchDataToInput(elements,MeshElementonbaseEnum);
 
 	if(isefficientlayer)iomodel->FetchDataToInput(elements,HydrologydcMaskEplactiveNodeEnum);
@@ -101,5 +101,5 @@
 	if(hydrology_model!=HydrologydcEnum) return;
 
-	if(iomodel->meshxdim!=Mesh2DhorizontalEnum) iomodel->FetchData(2,MeshVertexonbaseEnum,MeshVertexonsurfaceEnum);
+	if(iomodel->domaintype!=Mesh2DhorizontalEnum) iomodel->FetchData(2,MeshVertexonbaseEnum,MeshVertexonsurfaceEnum);
 	::CreateNodes(nodes,iomodel,HydrologyDCInefficientAnalysisEnum,P1Enum);
 	iomodel->DeleteData(2,MeshVertexonbaseEnum,MeshVertexonsurfaceEnum);
@@ -121,10 +121,10 @@
 	if(hydrology_model!=HydrologydcEnum) return;
 
-	if(iomodel->meshxdim==Mesh3DEnum) iomodel->FetchData(1,MeshVertexonbaseEnum);
+	if(iomodel->domaintype==Mesh3DEnum) iomodel->FetchData(1,MeshVertexonbaseEnum);
 
 	//create penalties for nodes: no node can have water above the max
 	CreateSingleNodeToElementConnectivity(iomodel);
 	for(int i=0;i<iomodel->numberofvertices;i++){
-		if (iomodel->meshxdim!=Mesh3DEnum){
+		if (iomodel->domaintype!=Mesh3DEnum){
 			/*keep only this partition's nodes:*/
 			if(iomodel->my_vertices[i]){
@@ -155,10 +155,10 @@
 
 	/*Intermediaries*/
-	int      meshxdim;
+	int      domaintype;
 	Element* basalelement;
 
 	/*Get basal element*/
-	element->FindParam(&meshxdim,MeshXDimEnum);
-	switch(meshxdim){
+	element->FindParam(&domaintype,DomainTypeEnum);
+	switch(domaintype){
 		case Mesh2DhorizontalEnum:
 			basalelement = element;
@@ -168,5 +168,5 @@
 			basalelement = element->SpawnBasalElement();
 			break;
-		default: _error_("mesh "<<EnumToStringx(meshxdim)<<" not supported yet");
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
 	}
 
@@ -254,5 +254,5 @@
 	xDelete<IssmDouble>(basis);
 	delete gauss;
-	if(meshxdim!=Mesh2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(domaintype!=Mesh2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
 	return Ke;
 }/*}}}*/
@@ -260,10 +260,10 @@
 
 	/*Intermediaries*/
-	int      meshxdim;
+	int      domaintype;
 	Element* basalelement;
 
 	/*Get basal element*/
-	element->FindParam(&meshxdim,MeshXDimEnum);
-	switch(meshxdim){
+	element->FindParam(&domaintype,DomainTypeEnum);
+	switch(domaintype){
 		case Mesh2DhorizontalEnum:
 			basalelement = element;
@@ -273,5 +273,5 @@
 			basalelement = element->SpawnBasalElement();
 			break;
-		default: _error_("mesh "<<EnumToStringx(meshxdim)<<" not supported yet");
+		default: _error_("mesh "<<EnumToStringx(domaintype)<<" not supported yet");
 	}
 
@@ -357,5 +357,5 @@
 	xDelete<IssmDouble>(basis);
 	delete gauss;
-	if(meshxdim!=Mesh2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(domaintype!=Mesh2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
 	return pe;
 }/*}}}*/
@@ -392,11 +392,11 @@
 void HydrologyDCInefficientAnalysis::InputUpdateFromSolution(IssmDouble* solution,Element* element){/*{{{*/
 
-	int        meshxdim;
+	int        domaintype;
 	bool       converged;
 	int*       doflist=NULL;
 	Element*   basalelement=NULL;
 
-	element->FindParam(&meshxdim,MeshXDimEnum);
-	if(meshxdim!=Mesh2DhorizontalEnum){
+	element->FindParam(&domaintype,DomainTypeEnum);
+	if(domaintype!=Mesh2DhorizontalEnum){
 		if(!element->IsOnBase()) return;
 		basalelement=element->SpawnBasalElement();
@@ -446,5 +446,5 @@
 	xDelete<IssmDouble>(residual);
 	xDelete<int>(doflist);
-	if(meshxdim!=Mesh2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
+	if(domaintype!=Mesh2DhorizontalEnum){basalelement->DeleteMaterials(); delete basalelement;};
 }/*}}}*/
 void HydrologyDCInefficientAnalysis::UpdateConstraints(FemModel* femmodel){/*{{{*/